searchNodes=[{"type":"module","title":"Membrane.RTP.H265.AP","doc":"Module responsible for parsing Aggregation Packets. Documented in RFC7798 0 1 2 3 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | RTP Header | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | PayloadHdr ( Type = 48 ) | NALU 1 Size | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | NALU 1 HDR | | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + NALU 1 Data | | . . . | | | + + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | . . . | NALU 2 Size | NALU 2 HDR | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | NALU 2 HDR | | + - + - + - + - + - + - + - + - + NALU 2 Data | | . . . | | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | :... OPTIONAL RTP padding | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + A packet width DONL 0 1 2 3 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | RTP Header | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | PayloadHdr ( Type = 48 ) | NALU 1 DONL | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | NALU 1 Size | NALU 1 HDR | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | | | NALU 1 Data . . . | | | + . . . + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | | NALU 2 DOND | NALU 2 Size | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | NALU 2 HDR | | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + NALU 2 Data | | | | . . . + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | :... OPTIONAL RTP padding | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - +","ref":"Membrane.RTP.H265.AP.html"},{"type":"function","title":"Membrane.RTP.H265.AP.aggregation_unit_size/1","doc":"","ref":"Membrane.RTP.H265.AP.html#aggregation_unit_size/1"},{"type":"function","title":"Membrane.RTP.H265.AP.parse/2","doc":"","ref":"Membrane.RTP.H265.AP.html#parse/2"},{"type":"function","title":"Membrane.RTP.H265.AP.serialize/4","doc":"","ref":"Membrane.RTP.H265.AP.html#serialize/4"},{"type":"type","title":"Membrane.RTP.H265.AP.don/0","doc":"","ref":"Membrane.RTP.H265.AP.html#t:don/0"},{"type":"module","title":"Membrane.RTP.H265.Depayloader","doc":"Depayloads H265 RTP payloads into H265 NAL Units. Based on RFC 7798 . Supported types: Single NALU, Fragmentation Unit, Aggegration Packets. Element options Passed via struct Membrane.RTP.H265.Depayloader.t/0 sprop_max_don_diff 0 .. 32767 Default value: 0 Specify the maximum absolute difference between the decoding order number (i.e. AbsDon) values of any two NAL units naluA and naluB, where naluA follows naluB in decoding order and precedes naluB in transmission order. If this value is greater than 0, then two additional fields DONL and DOND will be included in the RTP payload. A decoding_order_number field will be added to the buffer metadata. Pads :input Accepted formats: RTP Direction: :input Availability: :always Flow control: :auto :output Accepted formats: % H265 { alignment : :nalu , stream_structure : :annexb } Direction: :output Availability: :always Flow control: :auto","ref":"Membrane.RTP.H265.Depayloader.html"},{"type":"function","title":"Membrane.RTP.H265.Depayloader.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTP.H265.Depayloader.html#options/0"},{"type":"type","title":"Membrane.RTP.H265.Depayloader.t/0","doc":"Struct containing options for Membrane.RTP.H265.Depayloader","ref":"Membrane.RTP.H265.Depayloader.html#t:t/0"},{"type":"module","title":"Membrane.RTP.H265.FU","doc":"Module responsible for parsing H265 Fragmentation Unit.","ref":"Membrane.RTP.H265.FU.html"},{"type":"function","title":"Membrane.RTP.H265.FU.parse/3","doc":"Parses H265 Fragmentation Unit If a packet that is being parsed is not considered last then a {:incomplete, t()} tuple will be returned. In case of last packet {:ok, {type, data, don}} tuple will be returned, where data is NAL Unit created by concatenating subsequent Fragmentation Units and don is the decoding order number of the NAL unit in case donl field is present in the packet.","ref":"Membrane.RTP.H265.FU.html#parse/3"},{"type":"function","title":"Membrane.RTP.H265.FU.serialize/2","doc":"Serialize H265 unit into list of FU payloads","ref":"Membrane.RTP.H265.FU.html#serialize/2"},{"type":"type","title":"Membrane.RTP.H265.FU.don/0","doc":"","ref":"Membrane.RTP.H265.FU.html#t:don/0"},{"type":"type","title":"Membrane.RTP.H265.FU.t/0","doc":"","ref":"Membrane.RTP.H265.FU.html#t:t/0"},{"type":"module","title":"Membrane.RTP.H265.FU.Header","doc":"Defines a structure representing Fragmentation Unit (FU) header which is defined in RFC7798 + -- -- -- -- -- -- -- - + | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | + - + - + - + - + - + - + - + - + | S | E | FuType | + -- -- -- -- -- -- -- - +","ref":"Membrane.RTP.H265.FU.Header.html"},{"type":"function","title":"Membrane.RTP.H265.FU.Header.add_header/4","doc":"Adds FU header","ref":"Membrane.RTP.H265.FU.Header.html#add_header/4"},{"type":"function","title":"Membrane.RTP.H265.FU.Header.parse/1","doc":"Parses Fragmentation Unit Header It will fail if the Start bit and End bit are both set to one in the same Fragmentation Unit Header, because a fragmented NAL unit MUST NOT be transmitted in one FU.","ref":"Membrane.RTP.H265.FU.Header.html#parse/1"},{"type":"type","title":"Membrane.RTP.H265.FU.Header.end_flag/0","doc":"MUST be set to true only in the last packet in a sequence.","ref":"Membrane.RTP.H265.FU.Header.html#t:end_flag/0"},{"type":"type","title":"Membrane.RTP.H265.FU.Header.start_flag/0","doc":"MUST be set to true only in the first packet in a sequence.","ref":"Membrane.RTP.H265.FU.Header.html#t:start_flag/0"},{"type":"type","title":"Membrane.RTP.H265.FU.Header.t/0","doc":"","ref":"Membrane.RTP.H265.FU.Header.html#t:t/0"},{"type":"module","title":"Membrane.RTP.H265.NAL.Header","doc":"Defines a structure representing Network Abstraction Layer Unit Header Defined in RFC 7798 + -- -- -- -- -- -- -- - + -- -- -- -- -- -- -- - + | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7 | + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + - + | F | Type | LayerId | TID | + -- -- -- -- -- -- - + -- -- -- -- -- -- -- -- - +","ref":"Membrane.RTP.H265.NAL.Header.html"},{"type":"function","title":"Membrane.RTP.H265.NAL.Header.add_header/5","doc":"Adds NAL header to payload","ref":"Membrane.RTP.H265.NAL.Header.html#add_header/5"},{"type":"function","title":"Membrane.RTP.H265.NAL.Header.decode_type/1","doc":"Parses type stored in NAL Header","ref":"Membrane.RTP.H265.NAL.Header.html#decode_type/1"},{"type":"function","title":"Membrane.RTP.H265.NAL.Header.encode_type/1","doc":"Encodes given NAL type","ref":"Membrane.RTP.H265.NAL.Header.html#encode_type/1"},{"type":"function","title":"Membrane.RTP.H265.NAL.Header.parse_unit_header/1","doc":"","ref":"Membrane.RTP.H265.NAL.Header.html#parse_unit_header/1"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.nuh_layer_id/0","doc":"Required to be 0 in first version of HEVC, may be used in future extensions.","ref":"Membrane.RTP.H265.NAL.Header.html#t:nuh_layer_id/0"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.nuh_temporal_id_plus1/0","doc":"Specifies the temporal sub-layer identifier of the NAL unit plus 1.","ref":"Membrane.RTP.H265.NAL.Header.html#t:nuh_temporal_id_plus1/0"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.supported_types/0","doc":"","ref":"Membrane.RTP.H265.NAL.Header.html#t:supported_types/0"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.t/0","doc":"","ref":"Membrane.RTP.H265.NAL.Header.html#t:t/0"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.type/0","doc":"Specifies the type of RBSP data structure contained in the NAL unit.","ref":"Membrane.RTP.H265.NAL.Header.html#t:type/0"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.types/0","doc":"","ref":"Membrane.RTP.H265.NAL.Header.html#t:types/0"},{"type":"type","title":"Membrane.RTP.H265.NAL.Header.unsupported_types/0","doc":"","ref":"Membrane.RTP.H265.NAL.Header.html#t:unsupported_types/0"},{"type":"module","title":"Membrane.RTP.H265.Payloader","doc":"Payloads H265 NAL units into RTP packets. Based on RFC 7798 . Element options Passed via struct Membrane.RTP.H265.Payloader.t/0 max_payload_size non_neg_integer ( ) Default value: 1400 Maximal size of outputted payloads in bytes. Doesn't work in the single_nalu mode. The resulting RTP packet will also contain RTP header (12B) and potentially RTP extensions. For most applications, everything should fit in standard MTU size (1500B) after adding L3 and L2 protocols' overhead. mode :single_nalu | :non_interleaved Default value: :non_interleaved In :single_nalu mode, payloader puts exactly one NAL unit into each payload, altering only RTP metadata. :non_interleaved mode handles also FU and AP packetization. See RFC 7798 for details. Pads :input Accepted formats: % H265 { alignment : :nalu , stream_structure : :annexb } Direction: :input Availability: :always Flow control: :auto :output Accepted formats: RTP Direction: :output Availability: :always Flow control: :auto","ref":"Membrane.RTP.H265.Payloader.html"},{"type":"function","title":"Membrane.RTP.H265.Payloader.options/0","doc":"Returns description of options available for this module","ref":"Membrane.RTP.H265.Payloader.html#options/0"},{"type":"type","title":"Membrane.RTP.H265.Payloader.t/0","doc":"Struct containing options for Membrane.RTP.H265.Payloader","ref":"Membrane.RTP.H265.Payloader.html#t:t/0"},{"type":"extras","title":"Membrane RTP H265 plugin","doc":"RTP payloader and depayloader for H265.","ref":"readme.html"},{"type":"extras","title":"Membrane RTP H265 plugin - Supported packetization modes","doc":"This package does support the following (de)packetization modes: Single NALu Fragmentation Unit Aggregation Packets It does not support PACI packets. Please refer to RFC 7798 for details.","ref":"readme.html#supported-packetization-modes"},{"type":"extras","title":"Membrane RTP H265 plugin - Installation","doc":"The package can be installed by adding membrane_rtp_h265_plugin to your list of dependencies in mix.exs : def deps do [ { :membrane_rtp_h265_plugin , &quot;~&gt; 0.5.0&quot; } ] end","ref":"readme.html#installation"},{"type":"extras","title":"LICENSE","doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2019 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html"}]